import pygame
import gfxobject

# By Willi Kappler <grandor@gmx.de>
# Licensed under GPL

class Game:
    def __init__(self, screen, level, options, highscore):
        self.screen = screen
        self.black = (0, 0, 0)
        self.level = level
        self.options = options
        self.highscore = highscore
        self.clock = pygame.time.Clock()

    def run(self):
        self.level.level = 1
        self.level.quitGame = False
        self.level.load()
        self.level.createObj()
        while not self.level.quitGame:
            self.level.go()
            self.clock.tick(30)
            pygame.display.flip()

            for event in pygame.event.get([pygame.QUIT, pygame.KEYDOWN, pygame.KEYUP]):
                if event.type == pygame.QUIT:
                    self.level.quitGame = True
                elif event.type == pygame.KEYDOWN:
                    if event.key == pygame.K_ESCAPE:
                        self.level.quitGame = True
                    elif event.key == self.options.jump:
                        self.level.player.jump()
                    elif event.key == self.options.duck:
                        self.level.player.duck()
                    elif event.key == self.options.left:
                        self.level.player.moveLeft()
                    elif event.key == self.options.right:
                        self.level.player.moveRight()
                    elif event.key == self.options.action:
                        self.level.player.doAction()
                    elif event.key == pygame.K_n:
                        self.level.exitReached()
                elif event.type == pygame.KEYUP:
                    if event.key == self.options.duck:
                        self.level.player.standUp()
                    elif event.key == self.options.left:
                        self.level.player.lookLeft()
                    elif event.key == self.options.right:
                        self.level.player.lookRight()
        self.level.fancyFill(1)
        self.highscore.check(self.level.player.points)
