import gfxobject
import random

# By Willi Kappler <grandor@gmx.de>
# Licensed under GPL

class Shredder(gfxobject.Object):
    def __init__(self, screen, level, gfx, x, y):
        gfxobject.Object.__init__(self, screen, level, gfx, x, y)

        self.animList = [[9,8,7,6,5,4,3,2,1,0], [0,1,2,3,4,5,6,7,8,9]]
        self.moveLeft()
        self.moveAction = [self.moveLeft, self.moveRight, self.moveDown, self.moveLeft]
        self.moveAnim = [0,1,0,1,0]
        self.animTimes = [20,20]

    def check(self):
        if self.direction == 1:
            if self.checkDown():
                self.moveDown()
            elif self.checkRight() and (not self.asleep):
                self.moveLeft()
        elif self.direction == 2:
            if self.checkDown():
                self.moveDown()
            elif self.checkLeft() and (not self.asleep):
                self.moveRight()
        elif self.direction == 3:
            pass
        elif self.direction == 4:
            if not self.checkDown():
                self.y = (self.y / 32) * 32 # sane y coordinate
                d = random.randint(0,1)
                if d == 0:
                    self.moveLeft()
                else:
                    self.moveRight()

