import gfxobject
import random

# By Willi Kappler <grandor@gmx.de>
# Licensed under GPL

class Snowball(gfxobject.Object):
    def __init__(self, screen, level, gfx, x, y):
        gfxobject.Object.__init__(self, screen, level, gfx, x, y)

        self.animList = [[0,0,1,1,2,2,3,3],[4,4,5,5,6,6,7,7]]
        self.moveLeft()
        self.moveAction = [self.moveLeft, self.moveRight, self.moveDown, self.moveUp]
        self.moveAnim = [0,1,0,1,0]
        self.animTimes = [40,40]

    def check(self):
        if self.direction == 1:
            rt = self.getRT()
            rb = self.getRB()
            if (rt == self.level.objNo) or (rb == self.level.objNo):
                self.level.exitReached()
            elif (rt == self.level.switch1R) and (rb == self.level.switch1R):
                self.moveLeft()
                self.level.doSwitch1()
            elif (rt == self.level.switch2R) and (rb == self.level.switch2R):
                self.moveLeft()
                self.level.doSwitch2()
            elif (rt == self.level.switch3R) and (rb == self.level.switch3R):
                self.moveLeft()
                self.level.doSwitch3()
            elif (rt == self.level.switch4R) and (rb == self.level.switch4R):
                self.moveLeft()
                self.level.doSwitch4()
            elif self.checkRight():
                self.moveLeft()
            if self.checkDown():
                self.moveDown()
        elif self.direction == 2:
            lt = self.getLT()
            lb = self.getLB()
            if (lt == self.level.objNo) or (lb == self.level.objNo):
                self.level.exitReached()
            elif (lt == self.level.switch1L) and (lb == self.level.switch1L):
                self.moveRight()
                self.level.doSwitch1()
            elif (lt == self.level.switch2L) and (lb == self.level.switch2L):
                self.moveRight()
                self.level.doSwitch2()
            elif (lt == self.level.switch3L) and (lb == self.level.switch3L):
                self.moveRight()
                self.level.doSwitch3()
            elif (lt == self.level.switch4L) and (lb == self.level.switch4L):
                self.moveRight()
                self.level.doSwitch4()
            elif self.checkLeft():
                self.moveRight()
            if self.checkDown():
                self.moveDown()
        elif self.direction == 3:
            pass
        elif self.direction == 4:
            if not self.checkDown():
                self.y = (self.y / 32) * 32 # sane y coordinate
                d = random.randint(0,1)
                if d == 0:
                    self.moveLeft()
                else:
                    self.moveRight()

